#include <iostream>
#include <string>
#include "FBullCowGame.h"

using FText = std::string;
using int32 = int;

void Printintro();
void PlayGame();
FText GetGuess();
bool AskPlayAgain();

FBullCowGame BCGame;

int main()
{
	bool bPlayAgain = false;
	do {
		Printintro();
		PlayGame();
		bPlayAgain = AskPlayAgain();
	} while (bPlayAgain);

	return 0; // exit the application
}

// introduce the game
void Printintro()
{
	constexpr int32 WORLD_LENGTH = 5;
	std::cout << "Welcome to Bulls and Cows\n";
	std::cout << "A fun word game.\n" << std::endl;
	std::cout << "Can you guess the " << WORLD_LENGTH;
	std::cout << " letter isogram I'm thinking of?\n";
	std::cout << std::endl;
	return;
}

void PlayGame()
{
	BCGame.reset();
	
	// loop for the number of turns asking for guesses
	int32 MyMaxTries = BCGame.GetMaxTries();
	constexpr int32 NUMBER_OF_TURNS = 5;
	for (int32 count = 1; count <= NUMBER_OF_TURNS; count++) {
		FText Guess = GetGuess();
		std::cout << "Your guess was: " << Guess << std::endl;
		std::cout << std::endl;

		// Submit a valid guess to the game, and receive counts
		BullCowCounts BullCowCounts = BCGame.SubmitsGuess(Guess);
		// Print number of bulls and cows
		std::cout << "Bulls: " << BullCowCounts.BullCounts;
		std::cout << ". Cows: " << BullCowCounts.CowCounts << std::endl;

	}
}

FText GetGuess()
{
	// get a guess from the player
	int32 MyCurrentTry = BCGame.GetCurrentTry();
	std::cout << "try " << MyCurrentTry << ". ";
	std::cout << "Enter your guess: ";
	FText Guess = "";
	std::getline(std::cin, Guess);

	return Guess;
}

bool AskPlayAgain()
{
	std::cout << "Do you want to play again (Y,N)? ";
	FText respond;
	std::getline(std::cin, respond);
	std::cout << std::endl;

	return (respond[0] == 'y') || (respond[0] == 'Y');
}
